SystemOrganization addCategory: #'Meta-Examples'!

MMeta subclass: #MMetaParser
	instanceVariableNames: 'mDefMemo mDefNextPos mExpr1Memo mExpr1NextPos mExpr2Memo mExpr2NextPos mExpr3Memo mExpr3NextPos mExpr4Memo mExpr4NextPos mExprMemo mExprNextPos'
	classVariableNames: 'Primitives'
	poolDictionaries: ''
	category: 'Meta-Examples'!

!MMetaParser class methodsFor: 'instance creation' stamp: 'tfel 8/6/2016 13:04'!
initialize
	"after loading everything, Monticello calls this"
	MMetaCompiler useBootstrap: false.! !

!MMetaParser class methodsFor: 'grammar handling' stamp: 'aw 2/20/2007 18:15'!
tokenizer
	^ MMetaTokenizer! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemDef
	mDefMemo _ Array new: stream size + 1 withAll: Untried.
	mDefNextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr
	mExprMemo _ Array new: stream size + 1 withAll: Untried.
	mExprNextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr1
	mExpr1Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr1NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr2
	mExpr2Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr2NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr3
	mExpr3Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr3NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemExpr4
	mExpr4Memo _ Array new: stream size + 1 withAll: Untried.
	mExpr4NextPos _ Array new: stream size + 1! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/6/2007 19:03'!
mDef ::=
	<anything>:n ?`n is: #name` #'::=' <mExpr>:v ~<anything> `{#macroDef:. n value asString. v}`! !

!MMetaParser methodsFor: 'productions' stamp: 'aw 2/20/2007 18:19'!
mExpr ::=
	<mExpr4>:x (#'|' <mExpr4>)*:xs `(Array with: #macroOr: with: x), xs`! !

!MMetaParser methodsFor: 'productions' stamp: 'tfel 8/10/2016 09:57'!
mExpr1 ::=
	#'<' <anything>:n ?`n is: #name` #'>' `{#macroApp:. n value asString}` |
	<anything>:t ?`t isString & t isSymbol not` `{#macroString:. t}` |
	<anything>:t ?`t is: #symbol` `{#macroSymbol:. t value}` |
	<anything>:t ?`t isCharacter` `{#macroCharacter:. t}` |
	<anything>:t ?`t isInterval` `{#macroInterval:. t}` |
	<anything>:t ?`t is: #predCode` `{#macroPred:. t value}` |
	<anything>:t ?`t is: #code` `{#macroAns:. t value}` |
	#'(' <mExpr>:r #')' `r`! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/5/2007 14:56'!
mExpr2 ::=
	#'~' <mExpr2>:e `{#macroNot:. e}` |
	#'&' <mExpr2>:e `{#macroAndP:. e}` |
	<mExpr1>! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/17/2007 19:29'!
mExpr3 ::=
	<mExpr2>:r
	(
		#'*' `{#macroMany:. r}`:r |
		#'+' `{#macroMany1:. r}`:r |
		#'?' `{#macroQuestion:. r}`:r |
		?`true`
	)
	(
		<anything>:t ?`t = #'=>'`
			<anything>:t ?`t = #<`
				<anything>:n ?`n is: #name`
					<anything>:t ?`t = #>`
						`{#macroForm:. r. n value asString}`:r
	)*
	(
		#':' <anything>:n ?`n is: #name` `{#macroBind:. n value asString. r}`:r |
		?`true`
	)
	`r`! !

!MMetaParser methodsFor: 'productions' stamp: 'yo 5/17/2007 21:45'!
mExpr4 ::=
	<mExpr3>+:r `(Array with: #macroAnd:), r`
! !

MMeta subclass: #MTokenizer
	instanceVariableNames: 'charMemo charNextPos spaceMemo spaceNextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

MTokenizer subclass: #MMetaTokenizer
	instanceVariableNames: 'metaCharMemo metaCharNextPos metaCodeMemo metaCodeNextPos metaNameMemo metaNameNextPos metaStringMemo metaStringNextPos metaSymbolMemo metaSymbolNextPos metaSpecialMemo metaSpecialNextPos tokenMemo tokenNextPos tokenizeMemo tokenizeNextPos metaCommentMemo metaCommentNextPos commentMemo commentNextPos whitespaceMemo whitespaceNextPos metaSpecial2Memo metaSpecial2NextPos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Meta-Examples'!

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:48'!
comment ::=
	$" (~$" <anything>)* $"! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializecomment
	commentMemo _ Array new: stream size + 1 withAll: Untried.
	commentNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaChar
	metaCharMemo _ Array new: stream size + 1 withAll: Untried.
	metaCharNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaCode
	metaCodeMemo _ Array new: stream size + 1 withAll: Untried.
	metaCodeNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaName
	metaNameMemo _ Array new: stream size + 1 withAll: Untried.
	metaNameNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaSpecial
	metaSpecialMemo _ Array new: stream size + 1 withAll: Untried.
	metaSpecialNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 8/5/2016 15:46'!
initializemetaSpecial2
	metaSpecial2Memo _ Array new: stream size + 1 withAll: Untried.
	metaSpecial2NextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaString
	metaStringMemo _ Array new: stream size + 1 withAll: Untried.
	metaStringNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializemetaSymbol
	metaSymbolMemo _ Array new: stream size + 1 withAll: Untried.
	metaSymbolNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetoken
	tokenMemo _ Array new: stream size + 1 withAll: Untried.
	tokenNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializetokenize
	tokenizeMemo _ Array new: stream size + 1 withAll: Untried.
	tokenizeNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializewhitespace
	whitespaceMemo _ Array new: stream size + 1 withAll: Untried.
	whitespaceNextPos _ Array new: stream size + 1! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:44'!
metaChar ::=
	$$ <anything>:c1 '..' <anything>:c2 `(Interval from: c1 to: c2)` |
	$$ <anything>! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:44'!
metaCode ::=
	'?`' (~'`' <anything>)*:s '`' `MToken type: #predCode value: (String newFrom: s)` |
	'`' (~'`' <anything>)*:s '`' `MToken type: #code value: (String newFrom: s)`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/7/2016 10:09'!
metaName ::=
	<anything>:c ?`c isLetter` (<anything>:d ?`d isAlphaNumeric` `d`)*:s `MToken type: #name value: (String newFrom: c asString, (s joinSeparatedBy: ''))`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/5/2016 15:45'!
metaSpecial ::=
	$< `#<` |
	$> `#>` |
	$? `#?` |
	$( `#'('` |
	$) `#')'` |
	$~ `#~` |
	<metaSpecial2>:s `s`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'tfel 8/5/2016 15:46'!
metaSpecial2 ::=
	$& `#&` |
	$* `#*` |
	$+ `#+` |
	$| `#|` |
	'::=' `#'::='` |
	'=>' `#'=>'` |
	$: `#:`

! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:48'!
metaString ::=
	$' (&($' $') <anything> <anything> `$'` | ~$' <anything>)*:st $' `String newFrom: st`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:43'!
metaSymbol ::=
	$# <metaName>:n `MToken type: #symbol value: n symbol` |
	$# <metaString>:s `MToken type: #symbol value: (Symbol newFrom: s)`! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:42'!
token ::=
	<whitespace> (<metaChar> | <metaCode> | <metaName> | <metaString> | <metaSymbol> | <metaSpecial>)! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'aw 2/20/2007 18:10'!
tokenize ::=
	<token>*! !

!MMetaTokenizer methodsFor: 'productions' stamp: 'yo 5/17/2007 21:42'!
whitespace ::=
	(<space> | <comment>)*! !

!MTokenizer methodsFor: 'productions' stamp: 'aw 2/20/2007 18:12'!
char ::=
	<anything>:c ?`c isCharacter` `c`! !

!MTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializechar
	charMemo _ Array new: stream size + 1 withAll: Untried.
	charNextPos _ Array new: stream size + 1! !

!MTokenizer methodsFor: 'initializers' stamp: 'meta-auto 4/29/2010 12:12'!
initializespace
	spaceMemo _ Array new: stream size + 1 withAll: Untried.
	spaceNextPos _ Array new: stream size + 1! !

!MTokenizer methodsFor: 'productions' stamp: 'aw 2/20/2007 18:12'!
space ::=
	<char>:c ?`c <= $ ` `c`! !
MMetaParser initialize!
